Index: c/src/lib/libbsp/powerpc/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/ChangeLog	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/ChangeLog	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -1,2 +1,6 @@
+2008-07-14	Sebastian Huber <sebastian.huber@embedded-brains.de>
+
+	* mpc55xxevb: New BSP.
+
 2008-07-14	Thomas Doefler <Thomas.Doerfler@embedded-brains.de>
 	* haleakala: added new BSP
Index: c/src/lib/libbsp/powerpc/acinclude.m4
===================================================================
--- c/src/lib/libbsp/powerpc/acinclude.m4	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/acinclude.m4	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -15,4 +15,6 @@
   motorola_powerpc )
     AC_CONFIG_SUBDIRS([motorola_powerpc]);;
+  mpc55xxevb )
+    AC_CONFIG_SUBDIRS([mpc55xxevb]);;
   mpc8260ads )
     AC_CONFIG_SUBDIRS([mpc8260ads]);;
Index: c/src/lib/libbsp/powerpc/gen83xx/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/ChangeLog	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/ChangeLog	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -1,2 +1,16 @@
+2008-07-14	Sebastian Huber <sebastian.huber@embedded-brains.de>
+
+	* irq/irq_init.c, irq/irq.h, startup/linkcmds:
+	Removed.
+
+	* README.mpc8313erdb, include/irq-config.h, include/irq.h, irq/irq.c,
+	startup/linkcmds.base, startup/linkcmds.mpc8313erdb: New files.
+
+	* Makefile.am, configure.ac, console/config.c, console/console.c,
+	i2c/i2c_init.c, include/bsp.h, include/hwreg_vals.h, network/network.c,
+	spi/spi_init.c, start/start.S, startup/bspstart.c, startup/cpuinit.c,
+	startup/linkcmds.hsc_cm01, startup/linkcmds.mpc8349eamds: Support
+	MPC8313ERDB.
+
 2008-05-15	Joel Sherrill <joel.sherrill@OARcorp.com>
 
Index: c/src/lib/libbsp/powerpc/gen83xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -12,4 +12,6 @@
 include_HEADERS = include/bsp.h 
 include_HEADERS += include/tm27.h
+
+libcpudir = ../../../libcpu/@RTEMS_CPU@
 
 nodist_include_HEADERS = include/bspopts.h
@@ -34,24 +36,37 @@
 project_lib_DATA += rtems_crti.$(OBJEXT)
 
-dist_project_lib_DATA += startup/linkcmds \
+dist_project_lib_DATA += startup/linkcmds.base \
+                         startup/linkcmds.mpc8313erdb \
                          startup/linkcmds.mpc8349eamds \
                          startup/linkcmds.hsc_cm01
 
 mpc83xx_regs_SOURCES = startup/mpc83xx_regs.c
-startup_SOURCES = ../../shared/bspclean.c ../../shared/bsplibc.c \
-    ../../shared/bsppost.c startup/bspstart.c ../../shared/bootcard.c \
-    ../../shared/bsppredriverhook.c \
-    ../../shared/sbrk.c ../../shared/gnatinstallhandler.c startup/cpuinit.c
-pclock_SOURCES = ../../powerpc/shared/clock/p_clock.c
 
-include_bsp_HEADERS = ./irq/irq.h \
-    ./include/hwreg_vals.h        \
-    ../../powerpc/shared/vectors/vectors.h
+startup_SOURCES = ../../shared/bspclean.c \
+	../../shared/bsplibc.c \
+	../../shared/bsppost.c \
+	../../shared/bootcard.c \
+	../../shared/bsppredriverhook.c \
+	../../shared/sbrk.c \
+	../../shared/gnatinstallhandler.c \
+	../shared/src/tictac.c \
+	startup/cpuinit.c \
+	startup/bspstart.c
 
-vectors_SOURCES = ../../powerpc/shared/vectors/vectors.h \
-    ../../powerpc/shared/vectors/vectors_init.c \
-    ../../powerpc/shared/vectors/vectors.S
-irq_SOURCES = ./irq/irq.h ./irq/irq_init.c ./irq/ipic.c \
-	../shared/irq/irq_asm.S
+clock_SOURCES = ../shared/clock/clock.c
+
+include_bsp_HEADERS = include/irq.h \
+	include/irq-config.h \
+	../../shared/include/irq-generic.h \
+	include/hwreg_vals.h \
+	../shared/include/u-boot.h \
+	../shared/include/tictac.h
+
+irq_SOURCES = include/irq.h \
+	include/irq-config.h \
+	irq/irq.c \
+	../../shared/src/irq-generic.c \
+	../../shared/src/irq-legacy.c
+
 console_SOURCES = console/console.c console/ns16550cfg.c 
 bsp_i2c_SOURCES   = i2c/i2c_init.c 
@@ -67,22 +82,22 @@
 
 noinst_LIBRARIES = libbsp.a
-libbsp_a_SOURCES = $(startup_SOURCES) $(pclock_SOURCES) $(console_SOURCES) \
-    $(vectors_SOURCES) $(irq_SOURCES) $(mpc83xx_regs_SOURCES) \
+libbsp_a_SOURCES = $(startup_SOURCES) $(clock_SOURCES) $(console_SOURCES) \
+    $(irq_SOURCES) $(mpc83xx_regs_SOURCES) \
     $(bsp_i2c_SOURCES) $(bsp_spi_SOURCES)
 
-libbsp_a_LIBADD = \
-    ../../../libcpu/@RTEMS_CPU@/shared/cpuIdent.rel \
-    ../../../libcpu/@RTEMS_CPU@/shared/cache.rel \
-    ../../../libcpu/@RTEMS_CPU@/@exceptions@/rtems-cpu.rel \
-    ../../../libcpu/@RTEMS_CPU@/@exceptions@/raw_exception.rel \
-    ../../../libcpu/@RTEMS_CPU@/mpc6xx/mmu.rel   \
-    ../../../libcpu/@RTEMS_CPU@/mpc6xx/timer.rel \
-    ../../../libcpu/@RTEMS_CPU@/mpc6xx/clock.rel \
-    ../../../libcpu/@RTEMS_CPU@/mpc83xx/i2c.rel  \
-    ../../../libcpu/@RTEMS_CPU@/mpc83xx/spi.rel
+libbsp_a_LIBADD = $(libcpudir)/shared/cpuIdent.rel \
+	$(libcpudir)/shared/cache.rel \
+	$(libcpudir)/@exceptions@/rtems-cpu.rel \
+	$(libcpudir)/@exceptions@/raw_exception.rel \
+	$(libcpudir)/@exceptions@/exc_bspsupport.rel \
+	$(libcpudir)/mpc6xx/mmu.rel   \
+	$(libcpudir)/mpc6xx/timer.rel \
+	$(libcpudir)/mpc83xx/i2c.rel  \
+	$(libcpudir)/mpc83xx/spi.rel \
+	$(libcpudir)/mpc83xx/gtm.rel
 
 if HAS_NETWORKING
 libbsp_a_LIBADD += network.rel
-libbsp_a_LIBADD += ../../../libcpu/@RTEMS_CPU@/mpc83xx/tsec.rel
+libbsp_a_LIBADD += $(libcpudir)/mpc83xx/tsec.rel
 endif
 
Index: c/src/lib/libbsp/powerpc/gen83xx/README.mpc8313erdb
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/README.mpc8313erdb	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/gen83xx/README.mpc8313erdb	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,13 @@
+SPI:
+
+In master mode SCS (SPI_D) cannot be used as GPIO[31].  Unfortunately this pin
+is connected to the SD Card slot. See also [1] SPI 5.
+
+TSEC:
+
+The interrupt vector values are switched at the IPIC.  See also [1] IPIC 1.
+
+REFERENCES:
+
+[1]	MPC8313ECE Rev. 3, 3/2008: "MPC8313E PowerQUICCâ¢ II Pro Integrated Host
+	Processor Device Errata"
Index: c/src/lib/libbsp/powerpc/gen83xx/configure.ac
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/configure.ac	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/configure.ac	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -11,4 +11,5 @@
 AM_INIT_AUTOMAKE([no-define nostdinc foreign 1.10])
 RTEMS_BSP_CONFIGURE
+RTEMS_AMPOLISH3
 
 RTEMS_PROG_CC_FOR_TARGET([-ansi -fasm])
Index: c/src/lib/libbsp/powerpc/gen83xx/console/config.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/console/config.c	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/console/config.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -98,5 +98,13 @@
 		16,				/* ulMargin */
 		8,				/* ulHysteresis */
-		(void *)9600,	/* baud rate */	/* pDeviceParams */
+
+		/* pDeviceParams */
+		/* baud rate */
+#ifdef MPC8313ERDB
+		(void *)115200,
+#else /* MPC8313ERDB */
+		(void *)9600,
+#endif /* MPC8313ERDB */
+
                 (uint32_t)&(mpc83xx.duart[0]),  /* ulCtrlPort1e */
 		0,				/* ulCtrlPort2 */
@@ -118,5 +126,13 @@
                 16,                             /* ulMargin */
                 8,                              /* ulHysteresis */
-                (void *)9600,   /* baud rate */ /* pDeviceParams */
+
+		/* pDeviceParams */
+		/* baud rate */
+#ifdef MPC8313ERDB
+		(void *)115200,
+#else /* MPC8313ERDB */
+		(void *)9600,
+#endif /* MPC8313ERDB */
+
                 (uint32_t)&(mpc83xx.duart[1]),  /* ulCtrlPort1-Filled in at runtime */
                 0,                              /* ulCtrlPort2 */
Index: c/src/lib/libbsp/powerpc/gen83xx/console/console.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/console/console.c	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/console/console.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -45,4 +45,5 @@
 #include "console.h"
 #include <rtems/bspIo.h>
+#include <rtems/termiostypes.h>
 
 /*
@@ -99,4 +100,7 @@
 	status = rtems_termios_open ( major, minor, arg, &Callbacks);
 	Console_Port_Data[minor].termios_data = args->iop->data1;
+	if (status == 0) {
+		rtems_termios_set_initial_baud( Console_Port_Data [minor].termios_data, (int) Console_Port_Tbl [minor].pDeviceParams);
+	}
 
 	return status;
@@ -257,4 +261,9 @@
     Console_Port_Tbl[Console_Port_Minor].pDeviceFns->
       deviceWritePolled(Console_Port_Minor,c);
+
+    if (c == '\n') {
+      Console_Port_Tbl[Console_Port_Minor].pDeviceFns->
+        deviceWritePolled(Console_Port_Minor,'\r');
+    }
     
     rtems_interrupt_enable(Irql);
Index: c/src/lib/libbsp/powerpc/gen83xx/i2c/i2c_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/i2c/i2c_init.c	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/i2c/i2c_init.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -26,12 +26,12 @@
   {
     {/* public fields */
-      ops:	&mpc83xx_i2c_ops,
-      size:	sizeof(mpc83xx_i2c_bus_tbl[0]),
+      .ops = &mpc83xx_i2c_ops,
+      .size = sizeof(mpc83xx_i2c_bus_tbl[0]),
     },
     { /* our private fields */
-      reg_ptr:	 &mpc83xx.i2c[0],
-      initialized: FALSE,
-      irq_number :  BSP_IPIC_IRQ_I2C1,
-      base_frq   : 0 /* will be set during initiailization */
+      .reg_ptr = &mpc83xx.i2c[0],
+      .initialized = FALSE,
+      .irq_number = BSP_IPIC_IRQ_I2C1,
+      .base_frq = 0 /* will be set during initiailization */
     }
   },
@@ -39,12 +39,12 @@
   {
     { /* public fields */
-      ops:	&mpc83xx_i2c_ops,
-      size:	sizeof(mpc83xx_i2c_bus_tbl[1]),
+      .ops = &mpc83xx_i2c_ops,
+      .size = sizeof(mpc83xx_i2c_bus_tbl[1]),
     },
     { /* our private fields */
-      reg_ptr:	 &mpc83xx.i2c[1],
-      initialized: FALSE,
-      irq_number :  BSP_IPIC_IRQ_I2C2,
-      base_frq   : 0 /* will be set during initiailization */
+      .reg_ptr = &mpc83xx.i2c[1],
+      .initialized = FALSE,
+      .irq_number = BSP_IPIC_IRQ_I2C2,
+      .base_frq = 0 /* will be set during initiailization */
     }
   } 
@@ -115,4 +115,6 @@
   i2c2_busno = ret_code;
 
+#ifdef RTEMS_BSP_I2C_EEPROM_DEVICE_NAME
+
   /*
    * register EEPROM to bus 1, Address 0x50
@@ -121,7 +123,10 @@
 				       i2c_2b_eeprom_driver_descriptor,
 				       i2c1_busno,0x50);
+
   if (ret_code < 0) {
     return -ret_code;
   }
+
+#endif /* RTEMS_BSP_I2C_EEPROM_DEVICE_NAME */
 
   /*
Index: c/src/lib/libbsp/powerpc/gen83xx/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/include/bsp.h	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/include/bsp.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -21,5 +21,54 @@
 #define __GEN83xx_BSP_h
 
+/*
+ * MPC8313E Reference Design Board
+ */
+
+#ifdef MPC8313ERDB
+
+#define HAS_UBOOT
+
+/* For U-Boot */
+#define CONFIG_MPC83XX
+#define CONFIG_HAS_ETH1
+
+#endif /* MPC8313ERDB */
+
+#include <libcpu/powerpc-utility.h> 
+
 #include <bsp/hwreg_vals.h>
+
+/*
+ * Some symbols defined in the linker command file.
+ */
+
+LINKER_SYMBOL( bsp_ram_start);
+LINKER_SYMBOL( bsp_ram_end);
+LINKER_SYMBOL( bsp_ram_size);
+
+LINKER_SYMBOL( bsp_rom_start);
+LINKER_SYMBOL( bsp_rom_end);
+LINKER_SYMBOL( bsp_rom_size);
+
+LINKER_SYMBOL( bsp_section_text_start);
+LINKER_SYMBOL( bsp_section_text_end);
+LINKER_SYMBOL( bsp_section_text_size);
+
+LINKER_SYMBOL( bsp_section_data_start);
+LINKER_SYMBOL( bsp_section_data_end);
+LINKER_SYMBOL( bsp_section_data_size);
+
+LINKER_SYMBOL( bsp_section_bss_start);
+LINKER_SYMBOL( bsp_section_bss_end);
+LINKER_SYMBOL( bsp_section_bss_size);
+
+LINKER_SYMBOL( bsp_interrupt_stack_start);
+LINKER_SYMBOL( bsp_interrupt_stack_end);
+LINKER_SYMBOL( bsp_interrupt_stack_size);
+LINKER_SYMBOL( bsp_interrupt_stack_pointer);
+
+LINKER_SYMBOL( bsp_workspace_start);
+
+LINKER_SYMBOL( IMMRBAR);
 
 #ifndef ASM
@@ -36,4 +85,15 @@
 #include <bsp/irq.h>
 #include <bsp/vectors.h>
+#include <bsp/tictac.h>
+
+#ifdef HAS_UBOOT
+
+#include <bsp/u-boot.h>
+
+extern bd_t mpc83xx_uboot_board_info;
+
+extern const size_t mpc83xx_uboot_board_info_size;
+
+#endif /* HAS_UBOOT */
 
 /* miscellaneous stuff assumed to exist */
@@ -98,28 +158,21 @@
 
 /*
- *  Convert decrement value to tenths of microsecnds (used by
- *  shared timer driver).
- *
- *    + CPU has a csb_clock bus,
- *    + There are 4 bus cycles per click
- *    + We return value in 1/10 microsecond units.
- *   Modified following equation to integer equation to remove
- *   floating point math.
- *   (int) ((float)(_value) / ((XLB_CLOCK/1000000 * 0.1) / 4.0))
- */
-
-extern unsigned int BSP_bus_frequency;
-#define BSP_Convert_decrementer( _value ) \
-  (int) (((_value) * 4000) / (BSP_bus_frequency/10000))
-
-/*
  * Network driver configuration
  */
 struct rtems_bsdnet_ifconfig;
 extern int BSP_tsec_attach(struct rtems_bsdnet_ifconfig *config,int attaching);
+#define RTEMS_BSP_NETWORK_DRIVER_ATTACH	BSP_tsec_attach
+
+#ifdef MPC8313ERDB
+
+#define RTEMS_BSP_NETWORK_DRIVER_NAME	"tsec2"
+#define RTEMS_BSP_NETWORK_DRIVER_NAME2	"tsec1"
+
+#else /* MPC8313ERDB */
+
 #define RTEMS_BSP_NETWORK_DRIVER_NAME	"tsec1"
-#define RTEMS_BSP_NETWORK_DRIVER_ATTACH	BSP_tsec_attach
-
 #define RTEMS_BSP_NETWORK_DRIVER_NAME2	"tsec2"
+
+#endif /* MPC8313ERDB */
 
 #if defined(MPC8349EAMDS)
@@ -151,4 +204,17 @@
 #endif /* defined(HSC_CM01) */
 
+extern unsigned int BSP_bus_frequency;
+
+extern uint32_t bsp_clicks_per_usec;
+
+/*
+ *  Convert decrementer value to tenths of microseconds (used by shared timer
+ *  driver).
+ */
+#define BSP_Convert_decrementer( _value ) \
+  ((int) (((_value) * 10) / bsp_clicks_per_usec))
+
+void mpc83xx_zero_4( void *dest, size_t n);
+
 #ifdef __cplusplus
 }
Index: c/src/lib/libbsp/powerpc/gen83xx/include/hwreg_vals.h
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/include/hwreg_vals.h	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/include/hwreg_vals.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -22,4 +22,5 @@
 
 #include <mpc83xx/mpc83xx.h>
+
 /*
  * distinguish board characteristics
@@ -104,6 +105,13 @@
 			  RCWHR_LALE_NORM    |	\
 			  RCWHR_LDP_PAR)
+
+#elif defined( HAS_UBOOT)
+
+/* TODO */
+
 #else
+
 #error "board type not defined"
+
 #endif
 
@@ -112,26 +120,9 @@
  * for Freescale MPC8349EAMDS
  */
-/*
- * address range definitions
- */
-/* ROM definitions (8 MB, mirrored multiple times) */
-#define	ROM_START	0xFE000000
-#define ROM_SIZE        0x02000000
-#define	ROM_END		(ROM_START+ROM_SIZE-1)
-#define	BOOT_START      ROM_START
-#define	BOOT_END        ROM_END
-
-/* SDRAM definitions (256 MB) */
-#define	RAM_START       0x00000000
-#define RAM_SIZE        0x10000000
-#define	RAM_END		(RAM_START+RAM_SIZE-1)
-
-
-/* working internal memory map base address */
-#define	IMMRBAR         0xE0000000
 
 /*
  * working values for various registers, used in start/start.S
  */
+
 /*
  * Local Access Windows
@@ -184,26 +175,9 @@
  * for JPK HSC_CM01
  */
-/*
- * address range definitions
- */
-/* ROM definitions (8 MB, mirrored multiple times) */
-#define	ROM_START	0xFE000000
-#define ROM_SIZE        0x02000000
-#define	ROM_END		(ROM_START+ROM_SIZE-1)
-#define	BOOT_START      ROM_START
-#define	BOOT_END        ROM_END
-
-/* SDRAM definitions (256 MB) */
-#define	RAM_START       0x00000000
-#define RAM_SIZE        0x10000000
-#define	RAM_END		(RAM_START+RAM_SIZE-1)
-
-
-/* working internal memory map base address */
-#define	IMMRBAR         0xE0000000
 
 /*
  * working values for various registers, used in start/start.S
  */
+
 /*
  * Local Access Windows
@@ -211,9 +185,9 @@
  */
 
-#define LBLAWBAR0_VAL  ROM_START
+#define LBLAWBAR0_VAL  bsp_rom_start
 #define LBLAWAR0_VAL   0x80000018
 #define LBLAWBAR1_VAL  0xF8000000
 #define LBLAWAR1_VAL   0x80000015
-#define DDRLAWBAR0_VAL RAM_START
+#define DDRLAWBAR0_VAL bsp_ram_start
 #define DDRLAWAR0_VAL  0x8000001B
 /*
@@ -251,8 +225,14 @@
 #define DDR_SDRAM_INIT_ADDR_VAL      0
 #define DDR_SDRAM_INTERVAL_VAL       0x05080000
+
+#elif defined( HAS_UBOOT)
+
+/* TODO */
+
 #else
+
 #error "board type not defined"
+
 #endif
-
 
 /**************************
Index: c/src/lib/libbsp/powerpc/gen83xx/include/irq-config.h
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/include/irq-config.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/gen83xx/include/irq-config.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,78 @@
+/**
+ * @file
+ *
+ * @ingroup bsp_interrupt
+ *
+ * @brief BSP interrupt support configuration.
+ */
+
+/*
+ * Copyright (c) 2008
+ * Embedded Brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * rtems@embedded-brains.de
+ *
+ * The license and distribution terms for this file may be found in the file
+ * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+ */
+
+#ifndef LIBBSP_POWERPC_GEN83XX_IRQ_CONFIG_H
+#define LIBBSP_POWERPC_GEN83XX_IRQ_CONFIG_H
+
+#include <stdint.h>
+
+#include <bsp/irq.h>
+
+/**
+ * @addtogroup bsp_interrupt
+ *
+ * @{
+ */
+
+/**
+ * @brief Minimum vector number.
+ */
+#define BSP_INTERRUPT_VECTOR_MIN BSP_LOWEST_OFFSET
+
+/**
+ * @brief Maximum vector number.
+ */
+#define BSP_INTERRUPT_VECTOR_MAX BSP_MAX_OFFSET
+
+/**
+ * @brief Enables the index table.
+ *
+ * If you enable the index table, you have to define a size for the handler
+ * table (@ref BSP_INTERRUPT_HANDLER_TABLE_SIZE) and must provide an integer
+ * type capable to index the complete handler table (@ref
+ * bsp_interrupt_handler_index_type).
+ */
+#undef BSP_INTERRUPT_USE_INDEX_TABLE
+
+/**
+ * @brief Disables usage of the heap.
+ *
+ * If you define this, you have to define @ref BSP_INTERRUPT_USE_INDEX_TABLE as
+ * well.
+ */
+#undef BSP_INTERRUPT_NO_HEAP_USAGE
+
+#ifdef BSP_INTERRUPT_USE_INDEX_TABLE
+
+/**
+ * @brief Size of the handler table.
+ */
+#define BSP_INTERRUPT_HANDLER_TABLE_SIZE 63
+
+/**
+ * @brief Integer type capable to index the complete handler table.
+ */
+typedef uint8_t bsp_interrupt_handler_index_type;
+
+#endif /* BSP_INTERRUPT_USE_INDEX_TABLE */
+
+/** @} */
+
+#endif /* LIBBSP_POWERPC_GEN83XX_IRQ_CONFIG_H */
Index: c/src/lib/libbsp/powerpc/gen83xx/include/irq.h
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/include/irq.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/gen83xx/include/irq.h	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,147 @@
+/*===============================================================*\
+| Project: RTEMS generic MPC83xx BSP                              |
++-----------------------------------------------------------------+
+|                    Copyright (c) 2007                           |
+|                    Embedded Brains GmbH                         |
+|                    Obere Lagerstr. 30                           |
+|                    D-82178 Puchheim                             |
+|                    Germany                                      |
+|                    rtems@embedded-brains.de                     |
++-----------------------------------------------------------------+
+| The license and distribution terms for this file may be         |
+| found in the file LICENSE in this distribution or at            |
+|                                                                 |
+| http://www.rtems.com/license/LICENSE.                           |
+|                                                                 |
++-----------------------------------------------------------------+
+| this file declares constants of the interrupt controller        |
+\*===============================================================*/
+#ifndef GEN83xx_IRQ_IRQ_H
+#define GEN83xx_IRQ_IRQ_H
+
+#include <stdbool.h>
+
+#include <rtems.h>
+#include <rtems/irq.h>
+#include <rtems/irq-extension.h>
+
+/*
+ * the following definitions specify the indices used 
+ * to interface the interrupt handler API
+ */
+
+/*
+ * Peripheral IRQ handlers related definitions
+ */
+#define BSP_IPIC_PER_IRQ_NUMBER	        128
+#define BSP_IPIC_IRQ_LOWEST_OFFSET        0
+#define BSP_IPIC_IRQ_MAX_OFFSET      (BSP_IPIC_IRQ_LOWEST_OFFSET\
+                                         +BSP_IPIC_PER_IRQ_NUMBER-1)
+
+#define BSP_IS_IPIC_IRQ(irqnum)				\
+          (((irqnum) >= BSP_IPIC_IRQ_LOWEST_OFFSET) &&	\
+	   ((irqnum) <= BSP_IPIC_IRQ_MAX_OFFSET))
+/*
+ * Processor IRQ handlers related definitions
+ */
+#define BSP_PROCESSOR_IRQ_NUMBER        1
+#define BSP_PROCESSOR_IRQ_LOWEST_OFFSET	(BSP_IPIC_IRQ_MAX_OFFSET+1)
+#define BSP_PROCESSOR_IRQ_MAX_OFFSET	(BSP_PROCESSOR_IRQ_LOWEST_OFFSET\
+                                         +BSP_PROCESSOR_IRQ_NUMBER-1)
+
+#define BSP_IS_PROCESSOR_IRQ(irqnum)				\
+          (((irqnum) >= BSP_PROCESSOR_IRQ_LOWEST_OFFSET) &&	\
+	   ((irqnum) <= BSP_PROCESSOR_IRQ_MAX_OFFSET))
+/*
+ * Summary
+ */
+#define BSP_IRQ_NUMBER                  (BSP_PROCESSOR_IRQ_MAX_OFFSET+1)
+#define BSP_LOWEST_OFFSET		BSP_IPIC_IRQ_LOWEST_OFFSET
+#define BSP_MAX_OFFSET                  BSP_PROCESSOR_IRQ_MAX_OFFSET
+
+#define BSP_IS_VALID_IRQ(irqnum) 	\
+          (BSP_IS_PROCESSOR_IRQ(irqnum)	\
+           || BSP_IS_IPIC_IRQ(irqnum))
+
+#ifndef ASM
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+ * index table for the module specific handlers, a few entries are only placeholders
+ */
+  typedef enum {
+    BSP_IPIC_IRQ_FIRST	   = BSP_IPIC_IRQ_LOWEST_OFFSET,
+    BSP_IPIC_IRQ_ERROR	   = BSP_IPIC_IRQ_LOWEST_OFFSET +  0,
+    /* reserved irqs  1- 8 */
+    BSP_IPIC_IRQ_UART1	   = BSP_IPIC_IRQ_LOWEST_OFFSET +  9,
+    BSP_IPIC_IRQ_UART2 	   = BSP_IPIC_IRQ_LOWEST_OFFSET + 10,
+    BSP_IPIC_IRQ_SEC  	   = BSP_IPIC_IRQ_LOWEST_OFFSET + 11,
+    /* reserved irqs 12-13 */
+    BSP_IPIC_IRQ_I2C1      = BSP_IPIC_IRQ_LOWEST_OFFSET + 14,
+    BSP_IPIC_IRQ_I2C2      = BSP_IPIC_IRQ_LOWEST_OFFSET + 15,
+    BSP_IPIC_IRQ_SPI       = BSP_IPIC_IRQ_LOWEST_OFFSET + 16,
+    BSP_IPIC_IRQ_IRQ1      = BSP_IPIC_IRQ_LOWEST_OFFSET + 17,
+    BSP_IPIC_IRQ_IRQ2      = BSP_IPIC_IRQ_LOWEST_OFFSET + 18,
+    BSP_IPIC_IRQ_IRQ3      = BSP_IPIC_IRQ_LOWEST_OFFSET + 19,
+    BSP_IPIC_IRQ_IRQ4      = BSP_IPIC_IRQ_LOWEST_OFFSET + 20,
+    BSP_IPIC_IRQ_IRQ5      = BSP_IPIC_IRQ_LOWEST_OFFSET + 21,
+    BSP_IPIC_IRQ_IRQ6      = BSP_IPIC_IRQ_LOWEST_OFFSET + 22,
+    BSP_IPIC_IRQ_IRQ7      = BSP_IPIC_IRQ_LOWEST_OFFSET + 23,
+    /* reserved irqs 24-31 */
+    BSP_IPIC_IRQ_TSEC1_TX  = BSP_IPIC_IRQ_LOWEST_OFFSET + 32,
+    BSP_IPIC_IRQ_TSEC1_RX  = BSP_IPIC_IRQ_LOWEST_OFFSET + 33,
+    BSP_IPIC_IRQ_TSEC1_ERR = BSP_IPIC_IRQ_LOWEST_OFFSET + 34,
+    BSP_IPIC_IRQ_TSEC2_TX  = BSP_IPIC_IRQ_LOWEST_OFFSET + 35,
+    BSP_IPIC_IRQ_TSEC2_RX  = BSP_IPIC_IRQ_LOWEST_OFFSET + 36,
+    BSP_IPIC_IRQ_TSEC2_ERR = BSP_IPIC_IRQ_LOWEST_OFFSET + 37,
+    BSP_IPIC_IRQ_USB_DR    = BSP_IPIC_IRQ_LOWEST_OFFSET + 38,
+    BSP_IPIC_IRQ_USB_MPH   = BSP_IPIC_IRQ_LOWEST_OFFSET + 39,
+    /* reserved irqs 40-47 */
+    BSP_IPIC_IRQ_IRQ0      = BSP_IPIC_IRQ_LOWEST_OFFSET + 48,
+    /* reserved irqs 49-63 */
+    BSP_IPIC_IRQ_RTC_SEC   = BSP_IPIC_IRQ_LOWEST_OFFSET + 64,
+    BSP_IPIC_IRQ_PIT       = BSP_IPIC_IRQ_LOWEST_OFFSET + 65,
+    BSP_IPIC_IRQ_PCI1      = BSP_IPIC_IRQ_LOWEST_OFFSET + 66,
+    BSP_IPIC_IRQ_PCI2      = BSP_IPIC_IRQ_LOWEST_OFFSET + 67,
+    BSP_IPIC_IRQ_RTC_ALR   = BSP_IPIC_IRQ_LOWEST_OFFSET + 68,
+    BSP_IPIC_IRQ_MU        = BSP_IPIC_IRQ_LOWEST_OFFSET + 69,
+    BSP_IPIC_IRQ_SBA       = BSP_IPIC_IRQ_LOWEST_OFFSET + 70,
+    BSP_IPIC_IRQ_DMA       = BSP_IPIC_IRQ_LOWEST_OFFSET + 71,
+    BSP_IPIC_IRQ_GTM4      = BSP_IPIC_IRQ_LOWEST_OFFSET + 72,
+    BSP_IPIC_IRQ_GTM8      = BSP_IPIC_IRQ_LOWEST_OFFSET + 73,
+    BSP_IPIC_IRQ_GPIO1     = BSP_IPIC_IRQ_LOWEST_OFFSET + 74,
+    BSP_IPIC_IRQ_GPIO2     = BSP_IPIC_IRQ_LOWEST_OFFSET + 75,
+    BSP_IPIC_IRQ_DDR       = BSP_IPIC_IRQ_LOWEST_OFFSET + 76,
+    BSP_IPIC_IRQ_LBC       = BSP_IPIC_IRQ_LOWEST_OFFSET + 77,
+    BSP_IPIC_IRQ_GTM2      = BSP_IPIC_IRQ_LOWEST_OFFSET + 78,
+    BSP_IPIC_IRQ_GTM6      = BSP_IPIC_IRQ_LOWEST_OFFSET + 79,
+    BSP_IPIC_IRQ_PMC       = BSP_IPIC_IRQ_LOWEST_OFFSET + 80,
+    /* reserved irqs 81-83 */
+    BSP_IPIC_IRQ_GTM3      = BSP_IPIC_IRQ_LOWEST_OFFSET + 84,
+    BSP_IPIC_IRQ_GTM7      = BSP_IPIC_IRQ_LOWEST_OFFSET + 85,
+    /* reserved irqs 86-89 */
+    BSP_IPIC_IRQ_GTM1      = BSP_IPIC_IRQ_LOWEST_OFFSET + 90,
+    BSP_IPIC_IRQ_GTM5      = BSP_IPIC_IRQ_LOWEST_OFFSET + 91,
+    /* reserved irqs 92-127 */
+
+    BSP_IPIC_IRQ_LAST     = BSP_IPIC_IRQ_MAX_OFFSET,
+  } rtems_irq_symbolic_name;
+
+rtems_status_code mpc83xx_ipic_set_mask( rtems_vector_number vector, rtems_vector_number mask_vector, bool mask);
+
+#define MPC83XX_IPIC_INTERRUPT_NORMAL 0
+
+#define MPC83XX_IPIC_INTERRUPT_SYSTEM 1
+
+#define MPC83XX_IPIC_INTERRUPT_CRITICAL 2
+
+rtems_status_code mpc83xx_ipic_set_highest_priority_interrupt( rtems_vector_number vector, int type);
+
+#ifdef __cplusplus
+}
+#endif
+#endif /* ASM */
+
+#endif /* GEN83XX_IRQ_IRQ_H */
